/******************** key.c *********************/
/* the functions in this modul are moderately system dependent. */
/* they handle keystrokes and edit a line. */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "types.h"
#include "files.h"
#include "header.h"
#include "sysdep.h"
#include "blocks.h"
#include "esearch.h"
#include "key.h"
#include "menu.h"

char buffer[BUFFERSIZE+32];
int cursoron=1;
static XEvent event;
extern int topslot;
#define MAXMAKROS 4096
char *makrop=0,*recordp=0,makros[MAXMAKROS]={0};
char *translatep=0;
int dotranslate=1;
#include "translate.h"

#define max(x,y) ((x)>(y))?(x):(y)

void draw_bline (void);
void record_end (void)
{	*recordp++=0; *recordp=0; recordp=0;
	draw_bline();
}

void record (int key)
{	if (!recordp) return;
	if (recordp<makros+MAXMAKROS-8) *recordp++=key;
	else record_end();
}

void makro_save (void)
{	char *p=makros;
	FILE *file;
	while (*p)
	{	while (*p) p++;
		p++;
	}
	p++;
	file=fopen("makros","wb");
	if (!file)
	{	form_alert(1,"[1][Could mot open|makros file][Abort]");
		return;
	}
	fwrite(makros,(size_t)1,p-makros,file);
	fclose(file);
}

void load_makros (void)
{	FILE *file;
	file=fopen("makros","rb");
	if (!file) return;
	fread(makros,(size_t)1,MAXMAKROS,file);
	fclose(file);
}

void scan_blanks (char **line, char *end, int *pos, int tabs)
/***** scan_blanks
	scan line for blanks and tabs.
	it helps in the auto indent feature.
******/
{	*pos=0;
	while (((**line==' ') || (**line==9)) && (*line<end)) 
		{	if (**line==9) *pos=(*pos/tabs+1)*tabs;
			else (*pos)++;
			(*line)++;
		}
}

void rightadj (blocktyp *bl, char *p, long size)
/******* rightadj
	adjust the block markers if size bytes at p are deleted.
*******/
{	if (bl->start>=p) bl->start+=size;
	if (bl->end>=p) bl->end+=size;
}

int edit_line (int key)
/******* edit_line
	a terrible function, which does all editing of a line.
	first the cursor position is brought to the active window.
	the line is then copied to a buffer, which is edited,
	all editing made visible on the screen, of course.
	It also handles screen up and down and other things by
	copying the line back and moving the cursor.
	if it cannot handle a key it returns it.
	the parameter key is only the entry key to this function. 
	the function grabs further keys, until it cannot handle one.
*******/
{	int x,y,slot,i;
	int oldcursor,newcursor,endkey=0,updated=0,toredraw=0;
	int note=0,p[4],le,pos,blockdef=0,withblanks,key1,wrapped=0;
	int dontknow=0,specialevent=0,cursornote=0;
	filetyp *ft;
	blocktyp bl,blback;
	long s;
	char *line,*l,*nextl,*bufferend,*cp,*p0,*p1,*cpold;
	
	/* get top window slot */
	slot=get_top();
	if (slot<0) return key;
	ft=files+slot;
	if (slot==block.slot) blockdef=1; /* handle block! */
	
contin:
	update_gap(ft->cursor.line,slot); /* update gap */

	/* bring cursor on screen */
	y=find_cursor(ft);
	if (y<0)
	{	line=ft->cursor.line; y=0;
		for (i=0; i<ft->hl/3; i++) 
		{	l=prev_line(line,ft);
			if (l==line) break;
			else
			{	line=l; y++;
			}
		}
		ft->topl=line;
		ft->cursor.y=y;
		fredraw(slot);
	}
	else ft->cursor.y=y;
	
	/* copy cursor line to edit buffer */
	line=ft->cursor.line;
	nextl=next_line(line,ft);
	if (nextl-line>BUFFERSIZE)
	{	
		error("Cannot edit lines|that long!");
		freset(slot);
		new_top();
		refresh_top();
		return 0;
	}
	if (nextl==line) nextl=ft->fend;
	if (nextl-line>0) memmove(buffer,line,nextl-line);
	bufferend=buffer+(nextl-line);
	*bufferend=0;
	
	/* make block relative to buffer line */
	if (blockdef)
	{	bl.start=buffer+(block.start-line);
		bl.end=buffer+(block.end-line);
		blback=block;
	}
	
	/* compute cursor position of line, switch cursor on. */
	x=ft->xl;
	y=(ft->cursor.y+1)*gl_hchar+ft->y;
	if (!cursoron && ft->cursor.x>=ft->left) 
		cursor(x+(ft->cursor.x-ft->left)*gl_wchar,y);
	cursoron=1;
	if (key==0) return 0;
	
	/* determine event. usually a key was pressed. */
	note=0; endkey=0; withblanks=0;

	/* edit a single line */
	while (1)
	{
		keyinsert:
		if (key) /* if key pressed */
		{	/* look for translation */
			if (dotranslate && !translatep && key>=0 && key<256)
			{	translatep=translatet[key];
				if (*translatep) key=*translatep++;
				else translatep=0;
			}
			ft->cursor.x=
				find_pos(buffer,ft->cursor.x,bufferend,&cp,ft->tabs);
			/* note cursor position and remove cursor */
			newcursor=oldcursor=ft->cursor.x;
			/* switch cursor off */
			if (cursoron && ft->cursor.x>=ft->left) 
				cursor(x+(ft->cursor.x-ft->left)
				*gl_wchar,y);
			cursoron=0;
			dontknow=0;
			/* in the following, note is set to 1, if there is left
				something to do after the editing */
			wrapped=0;
			keyswitch:
			switch(key) /* handle key */
			{	case 1 : break;
				case CLEFT : /* cursor left */
					record(2);
					if (newcursor<=0)
					{	note=1; endkey=1; break;
					}
					newcursor--; break;
				case CRIGHT : /* cursor right */
					record(3);
					if (cp>=bufferend || *cp==10)
					{	note=1; endkey=1; break;
					}
					if (*cp==9) 
						newcursor=(newcursor/ft->tabs+1)
							*ft->tabs;
					else newcursor++; 
					break;
				case LLEFT : newcursor=0; break; /* to start of line */
				case LRIGHT : newcursor=BUFFERSIZE; break; /* to end of line */
				case TBACKSPACE : /* delete to left */
					if (newcursor<=0) /* join lines */
					{	l=prev_line(line,ft);
						if (l==line) break;
						le=line-l-1;
						if (bufferend+le>buffer+BUFFERSIZE)
						{	error("This line to long!");
							break;
						}
						line=l;
						if (blockdef)
						{       bl.start+=le+1;
							bl.end+=le+1;
							rightadj(&bl,buffer+le,-1);
						}
						if (bufferend-buffer>0)
							memmove(buffer+le,buffer,bufferend-buffer);
						bufferend+=le;
						if (le>0) /* copy previous line from file */
							memmove(buffer,line,le);
						cp=buffer+le;
						cursornote=newcursor=oldcursor=
							position(buffer,bufferend,ft->tabs,cp);
						note=1; updated=1; endkey=1;
						break;
					}
					newcursor--;
				case TDELETE : /* delete char at cursor */
					/* that is to skip a TAB to the left: */
					oldcursor=newcursor=
						find_pos(buffer,newcursor,
							bufferend,&cp,ft->tabs);
					if (cp>bufferend) break;
					if (cp==bufferend || *cp==10) /* join lines */
					{	l=next_line(nextl,ft);
						if (l==nextl)  l=ft->fend;
						le=l-nextl;
						if (bufferend+le-1>buffer+BUFFERSIZE)
						{	error("This line is to long!");
							break;
						}
						if (blockdef) rightadj(&bl,cp,-1);
						if (le>0) /* copy next line from file */
							memmove(cp,nextl,le);
						nextl=l;
						bufferend+=le-1;
						note=1; updated=1; endkey=1;
						break;
					}
					rightadj(&bl,cp+1,-1);
					if (bufferend-cp-1>0)
						memmove(cp,cp+1,bufferend-cp-1);
					bufferend--; updated=1; toredraw=1;
					break;
				case TRETURN : /* split lines */
					record(1);
					if (ft->flags.blanks) /* del. trailing blanks */
					{	p0=cp;
						while ((cp>buffer)&&
							((*(cp-1)==' ')||(*(cp-1)==9))) cp--;
						if (p0>cp)
						{	if (p0!=bufferend)
							memmove(cp,p0,bufferend-p0);
							bufferend-=p0-cp;
							rightadj(&bl,p0,-(p0-cp));
						}
					}
					l=buffer;
					if (ft->flags.indent)
					{	scan_blanks(&l,cp,&pos,ft->tabs);
						le=(l-buffer);
					}
					else 
					{	le=0; pos=0; }
					if (blockdef) rightadj(&bl,cp,le+2);
					if (bufferend-cp>0) 
						memmove(cp+1+le,cp,bufferend-cp);
					*cp++=10; bufferend+=1+le;
					if (le>0)
						memmove(cp,buffer,le);
					withblanks=1;
					cursornote=oldcursor;
					updated=1; note=1; endkey=1; break;
				case WRIGHT : /* word right */
				case WLEFT : /* word left */
				case PUP : /* page up */
				case PDOWN : /* page down */
				case HPUP : /* half page up */
				case HPDOWN : /* half page down */
				case TEND : /* end of text */
				case TBEGIN : /* start of text */
				case CUP : /* cursor up */
				case CDOWN : /* cursor down */
				case LRETURN : /* to start of next line */
					note=1; endkey=1; break;
				case LDELETE : /* delete the line */
					if (blockdef) 
						rightadj(&bl,bufferend,-(bufferend-buffer));
					bufferend=buffer; cp=buffer; endkey=1;
					to_undo(line,nextl-line,slot);
					updated=1; note=1; break;
				case TABORT : /* abort program */
					gl_ende=abort_prog();
					if (gl_ende) 
					{	
						return 0;
					}
					break;
				case TINSERT : /* toggle insert */
					/* ft->flags.insert=!ft->flags.insert; */
					break;
				case TMAKRO :
					if (recordp) record_end();
					else makrop=makros;
					draw_bline();
					break;
				case TRECORD :
					if (recordp) record_end();
					else recordp=makros;
					draw_bline();
					break;
				case TTAB : key=9; /* TAB */
				default : /* also for TAB! */
					key1=key&0x00FF;
					if ((unsigned int)key<256 && key1!=0 && key1!=10 && key1!=13)
					{	record(key);
						if (bufferend>buffer+BUFFERSIZE)
						{	error("This line is to long!");
							break;
						}
						if (ft->flags.insert || key==9 || 
							*cp==13 || cp>=bufferend)
						{	if (bufferend-cp>0)
								memmove(cp+1,cp,bufferend-cp);
							bufferend++;
							if (blockdef) rightadj(&bl,cp,1);
						}
						*cp++=(key&0x00FF);
						if (key==9)			
							newcursor=(newcursor/ft->tabs+1)*ft->tabs;
						else newcursor++;
						if (ft->flags.wordwrap && 
								newcursor>ft->linelength)
						{	cpold=cp;
							if (*(cp-1)==9 || *(cp-1)==' ')
							{	wrapped=0; key=TRETURN;
								goto keyswitch;
							}
							else
							{	while (*cp!=9 && *cp!=' ' && 
									cp>buffer)
								{	cp--;
								}
								if (cp!=buffer)
								{	cp++; key=TRETURN; 
									wrapped=cpold-cp; 
									goto keyswitch;
								}
								else cp=cpold;
							}
						}
						updated=1; toredraw=1;
					}
					else { endkey=1; dontknow=1; }
			} /* switch(key) */
			if (updated && !ft->flags.updated)
			{	ft->flags.updated=1;
				draw_bline();
			}
			if (endkey && ft->flags.blanks && !withblanks) 
				/* remove trailing blanks */
			{	p0=bufferend-1;
				if ((p0>=buffer)&&(*p0==10)) p0--;
				p1=p0+1;
				while ((p0>=buffer)&&((*p0==' ')||(*p0==9))) p0--; 
				p0++;
				if (p0<buffer) p0=buffer;
				le=(p1-p0);
				if (le>0)
				{	if (bufferend>p1) memmove(p0,p1,bufferend-p1);
					if (blockdef) rightadj(&bl,p1,-le);
					bufferend-=le; updated=1;
				}
			}
			if (toredraw)
			/* redraw the line and blank rest of line 
				*** system dependent *** */
			{	
				if (blockdef) block=bl;
				oldcursor=max(oldcursor,ft->left);
				le=unscramble(buffer,bufferend,oldcursor,
					ft->wl+ft->left-oldcursor,
					ft->tabs,x+(oldcursor-ft->left)*gl_wchar,y,ft->w);
				toredraw=0;
				if (blockdef) block=blback;
			}

			/* check new cursor position */
			ft->cursor.x=find_pos(buffer,newcursor,bufferend,
				&cp,ft->tabs);

			/* cursor left or right of screen? */
			if (!note)
				if ((ft->cursor.x<ft->left) ||
					 (ft->cursor.x>=(ft->wl+ft->left)))
				{ note=-1; endkey=1; }
			if (!note) 
			{	if (ft->cursor.x>=ft->left)
				cursor(x+(ft->cursor.x-ft->left)*gl_wchar,y);
				cursoron=1;
			}
			if (endkey) break; /* stop editing this line */
		} /* if key */

		/* read next keyboard command, don't wait for it!
		 *** system dependent *** */
		if (dontknow || endkey) break;
		XFlush(display);
		if (makrop && makrop!=makros)
		{	if (*makrop)
			{	key=*makrop++;
				switch (key)
				{	case 1 : key=TRETURN; break;
					case 2 : key=CLEFT; break;
					case 3 : key=CRIGHT; break;
				}
				goto keyinsert;
			}
			else makrop=0;
		}
		else if (translatep)
		{	if (*translatep)
			{	key=*translatep++;
				goto keyinsert;
			}
			else translatep=0;
		}
		nextkey:
		XNextEvent(display,&event);
		specialevent=0;
		switch (event.type)
		{
			case KeyPress :
				key=translate(&event.xkey);
				if (!key) goto nextkey;
				if (makrop==makros)
				{	if (*makrop)
						while(*makrop!=key)
						{	while (*makrop) makrop++;
							makrop++;
							if (!*makrop) { makrop=0; break; }
						}
					else makrop=0;
					if (makrop) { makrop++; key=*makrop++; goto keyinsert; }
				}
				else if (recordp==makros)
				{	while (*recordp)
					{	if (*recordp==key)
							memmove(recordp,recordp+strlen(recordp)+1,
								MAXMAKROS-(recordp-makros)-strlen(recordp)-1);
						while (*recordp) recordp++;
						recordp++;
					}
					*recordp++=key; goto nextkey;
				}
				break;
			case MappingNotify :
			case Expose :
			case GraphicsExpose :
			case ConfigureNotify : specialevent=1; break;
			case ButtonPress : key=TBUTTON; specialevent=1; break;
		}
		if (updated && !ft->flags.updated)
		{	ft->flags.updated=1;
			draw_bline();
		}
		if (key==TBUTTON || !key || specialevent) { endkey=1; break; }
	} /* while(1). breaks, if there is an unknown key or endkey!=0 */
	
	/* insert line back */
	if (updated) /* insert line back */
	{	s=(bufferend-buffer)-(nextl-line);
		if (s<0)  fdelete(slot,nextl+s,-s);
		else if (s>0)
			if (!finsert(slot,nextl,s))
			{	cursoron=1;
				fredraw(slot);
				return 0;
			}
		if (bufferend-buffer>0) /* insert buffer */
			memmove(line,buffer,bufferend-buffer);
		ft->flags.updated=1;
	}
	/* take care of block! */
	if (blockdef)
	{	if (bl.start>=buffer && bl.start<=bufferend)
			block.start=line+(bl.start-buffer);
		if (bl.end>=buffer && bl.end<=bufferend)
			block.end=line+(bl.end-buffer);
	}
	
	/* user wishes to edit another line */
	ft->cursor.x=find_pos(line,
				ft->cursor.x,ft->fend,
				&(ft->cursor.adr),ft->tabs);
	p[0]=x; p[1]=y-2*gl_hchar;
	p[2]=x+ft->w; p[3]=ft->y+ft->h;
	if (specialevent)
	{	process_event(&event);
		return 0;
	}
	if (note) /* some keys need to be handled here */
	{	if (note>0) switch(key)
		{	case CUP :
				ft->cursor.line=prev_line(ft->cursor.line,ft);
				if (ft->cursor.line<ft->topl)
					vscroll(slot,-1);
				break;
			case CDOWN :
				ft->cursor.line=next_line(ft->cursor.line,ft);
				if (ft->cursor.y>=ft->hl-1)
					vscroll(slot,1);
				break;
			case TRETURN :
				ft->cursor.line=next_line(ft->cursor.line,ft);
				if (ft->cursor.y+1>=ft->hl) vscroll(slot,1);
				wredraw(slot,p,window);
				pos+=wrapped;
				ft->cursor.x=pos-ft->left;
				note=-1;
				break;
			case TBACKSPACE :
			case LDELETE :
				ft->cursor.x=cursornote;
				ft->cursor.line=line;
				if (line<ft->topl) ft->topl=ft->cursor.line;
				wredraw(slot,p,window);
				break;
			case TDELETE :
				wredraw(slot,p,window);
				break;
			case TBEGIN :
				ft->cursor.line=ft->topl=ft->start;
				ft->cursor.x=ft->cursor.y=0;
				refresh_top();
				break;
			case TEND :
				ft->topl=ft->fend;
				for (i=0; i<ft->hl/2; i++)
					ft->topl=prev_line(ft->topl,ft);
				ft->cursor.line=ft->topl;
				ft->cursor.x=ft->cursor.y=0;
				refresh_top();
				break;
			case PUP :
				vscroll(slot,-ft->hl+1);
				for (i=0; i<ft->hl-1; i++)
					ft->cursor.line=
						prev_line(ft->cursor.line,ft);
				break;
			case PDOWN :
				vscroll(slot,ft->hl-1);
				for (i=0; i<ft->hl-1; i++)
					ft->cursor.line=
						next_line(ft->cursor.line,ft);
				break;
			case HPUP :
				vscroll(slot,-ft->hl/2+1);
				for (i=0; i<ft->hl/2-1; i++)
					ft->cursor.line=
						prev_line(ft->cursor.line,ft);
				break;
			case HPDOWN :
				vscroll(slot,ft->hl/2-1);
				for (i=0; i<ft->hl/2-1; i++)
					ft->cursor.line=
						next_line(ft->cursor.line,ft);
				break;
			case CLEFT :
				ft->cursor.line=prev_line(ft->cursor.line,ft);
				if (ft->cursor.line<ft->topl)
					vscroll(slot,-1);
				ft->cursor.x=BUFFERSIZE;
				break;
			case CRIGHT :
			case LRETURN :
				ft->cursor.line=next_line(ft->cursor.line,ft);
				ft->cursor.y++;
				if (ft->cursor.y>=ft->hl) vscroll(slot,1);
				ft->cursor.x=0;
				note=-1;
				break;
			case WLEFT :
				p1=ft->cursor.adr; p1--;
				while (p1>=ft->start && (*p1==' ' || *p1==9 || *p1==10 
					|| *p1==13)) p1--;
				while (p1>=ft->start && *p1!=' ' && *p1!=9 && *p1!=10) 
					p1--;
				p1++;
				ft->cursor.adr=p1;
				ft->cursor.line=prev_line(p1+1,ft);
				ft->cursor.x=position(ft->cursor.line,ft->fend,
					ft->tabs,ft->cursor.adr);
				break;
			case WRIGHT :
				p1=ft->cursor.adr; p1++;
				while (p1<ft->fend && *p1!=' ' && *p1!=9 && *p1!=13) 
					p1++;
				while (p1<ft->fend && (*p1==' ' || *p1==9 || *p1==10 
					|| *p1==13)) p1++;
				ft->cursor.adr=p1;
				ft->cursor.line=prev_line(p1+1,ft);
				ft->cursor.x=position(ft->cursor.line,ft->fend,
					ft->tabs,ft->cursor.adr);
				break;				
		}
		ft->cursor.x=find_pos(ft->cursor.line,
				ft->cursor.x,ft->fend,
				&(ft->cursor.adr),ft->tabs);
		if (ft->cursor.x<ft->left)
			hscroll(slot,ft->cursor.x-ft->left-16);
		if (ft->cursor.x>=(ft->wl+ft->left))
			hscroll(slot,ft->cursor.x-(ft->wl+ft->left)+17);
		if (key==CDOWN || key==CUP || key==PUP || key==PDOWN
			|| key==HPUP || key==HPDOWN || key==TRETURN) 
				/* forget all keystrokes */
		{	XSync(display,0);
			while (XCheckMaskEvent(display,KeyPressMask,&event));
		}
		if (!makrop) key=0;
		else key=1;
		goto contin;
	}
	
	return key;
}

void home (void)
{	
	int slot;
	filetyp *ft;
	slot=topslot;
	if (slot<0) return;
	ft=files+slot;
	ft->cursor.line=ft->topl;
	ft->cursor.x=0;
	refresh_top();
	edit_line(0);
}

void menukey (int key)
{		
	switch (key)
	{	case TCYCLE : cycle_window(); break;
		case TSEARCH : show_search(); break;
		case TREPLACE : show_replace(); break;
		case TAGAIN : search_again(); break;
		case TBFORMAT : if (block.slot>=0) block_format(); break;
		case TPFORMAT : if (block.slot<0) block_format(); break;
		case TLOAD : load_file(); refresh_top(); break;
		case TSAVE : save_file(0); break;
		case TSAVEAS : save_as(); break;
		case TSAVEDUP: save_dup(); break;
		case TBBEGIN : block_start(); break;
		case TBEND : block_end(); break;
		case TBMOVE : block_move(); break;
		case TBCOPY : block_copy(); break;
		case TBDELETE : block_delete(); break;
		case TBHIDE : block_hide(); break;
		case TCLOSE : close_file(topslot); break;
		case TGOTO : show_goto(); break;
		case TCLOSEA : end_program(); break;
		case TSET1 : set_marker(0); break;
		case TSET2 : set_marker(1); break;
		case TSET3 : set_marker(2); break;
		case TSET4 : set_marker(3); break;
		case TGOTO1 : goto_marker(0); break;
		case TGOTO2 : goto_marker(1); break;
		case TGOTO3 : goto_marker(2); break;
		case TGOTO4 : goto_marker(3); break;
		case THOME : home(); break;
		case TUNDO : from_undo(); break;
		case TBLEFT : left_block(); break;
		case TBRIGHT : right_block(); break;
		case TBLINE : line_block(); break;
		case TABORT : end_program(); gl_ende=1; break;
		case TQUIT : gl_ende=end_program(); break;
		case TBUTTON : button_interpret(&event.xbutton); break;
		case TMENU : show_menu(); break;
		case TCINFO : show_cinfo(); break;
		case TPARAMS : show_params(); break;
		case TOLOAD : overload(); refresh_top(); break;
		case TWFIND : window_find(); break;
		case TSAVEALL : save_all(); break;
		case TBSAVE : block_save(); break;
		case TBLOAD : block_load(); break;
		case TBRACKETS : find_bracket(); break;
		case TCHECK : check_text(); break;
		case TEXTEND : extend_memory(); break;
		case TLINK : do_link(); break;
		case TMSAVE : makro_save(); break;
		case TCINSERT : show_cinsert(); break;
		case TSSAVE : backsave(); break;
		default : edit_line(key);
	}
}

void key_interpret (int key)
{	
	switch (key)
	{	case TCYCLE :
		case TGOTO1 :
		case TGOTO2 :
		case TGOTO3 :
		case TGOTO4 : 
		case THOME :
		case TUNDO :
			break;	
		default : key=edit_line(key);
	}
	menukey(key);
}

extern int hoffset,voffset;

void button_interpret (XButtonEvent *event)
{	
	int y,x1,y1,slot,mx,my,h,l;
	Window root,child;
	int root_x,root_y;
	unsigned int buttons;
	static int started=0;
	char *line,*newline;
	filetyp *ft;
	XEvent e;
	if (!(event->state & ControlMask) && event->button==Button3)
	{	show_menu();
		return;
	}
	slot=topslot;
	if (slot<0) return;
	ft=files+slot;
	mx=event->x; my=event->y;
	if (event->window==bwindow)
	{	show_menu();
		return;
	}
	if (params.scrollbar && event->window==vuwindow)
	{	while (!XCheckTypedEvent(display,ButtonRelease,&e))
			vscroll(slot,-1);
		return;
	}
	if (params.scrollbar && event->window==vdwindow)
	{	while (!XCheckTypedEvent(display,ButtonRelease,&e))
			vscroll(slot,1);
		return;
	}
	if (params.scrollbar && event->window==swindow)
	{	h=vheight-8-vwidth;
		XQueryPointer(display,vwindow,&root,&child,
			&root_x,&root_y,&x1,&y,&buttons);
		while (!XCheckTypedEvent(display,ButtonRelease,&e))
		{	XQueryPointer(display,vwindow,&root,&child,
				&root_x,&root_y,&x1,&y1,&buttons);
			if (buttons==0) return;
			if (abs(y-y1)<2) continue;
			y=y1;
			y1-=2+my;
			newline=ft->start+(ft->fend-ft->start)*y1/h;
			line=ft->topl;
			newline=prev_line(newline+1,ft);
			if (line==newline) continue;
			if (newline==next_line(line,ft)) vscroll(slot,1);
			else if (newline==next_line(next_line(line,ft),ft)) vscroll(slot,2);
			else if (newline==prev_line(line,ft)) vscroll(slot,-1);
			else if (newline==prev_line(prev_line(line,ft),ft)) vscroll(slot,-2);
			else { ft->topl=newline; refresh_top(); }
			XSync(display,0);
		}
		return;
	}
	if (params.scrollbar && event->window==vwindow)
	{	h=vheight-8-vwidth;
		l=(ft->topl-ft->start)*h/(ft->fend-ft->start+1)+2;
		if (my<l+vwidth/2)
		{	while (!XCheckTypedEvent(display,ButtonRelease,&e))
			{	vscroll(slot,-ft->hl+1);
				XSync(display,0);
			}
			return;
		}
		else
		{	while (!XCheckTypedEvent(display,ButtonRelease,&e))
			{	vscroll(slot,ft->hl-1);
				XSync(display,0);
			}
			return;
		}
	}
	/* find old cursor */
	x1=ft->cursor.x;
	y1=find_cursor(ft);
	line=ft->topl;
	my=(my-ft->y)/gl_hchar;
	mx=(mx-ft->xl)/gl_wchar;
	for (y=0; y<ft->hl; y++)
	{	if (y==my)
		{	ft->cursor.line=line;
			ft->cursor.y=y;
			ft->cursor.x=
				find_pos(line,mx+ft->left,ft->fend,
					&(ft->cursor.adr),ft->tabs);
			break;
		}
		newline=next_line(line,ft);
		if (newline==line)
		{	line=newline;
			ft->cursor.line=line;
			ft->cursor.y=y;
			ft->cursor.x=
				find_pos(line,mx+ft->left,ft->fend,
					&(ft->cursor.adr),ft->tabs);
			break;
		}
		else line=newline;
	}
	if (y1>=0 && x1>=ft->left) 
		cursor(ft->xl+(x1-ft->left)
			*gl_wchar,ft->y+(y1+1)*gl_hchar);
	if (ft->cursor.x>=ft->left)
		cursor(ft->xl+(ft->cursor.x-ft->left)*gl_wchar,
			ft->y+(ft->cursor.y+1)*gl_hchar);
	if (event->state & ControlMask)
	{	switch (event->button)
		{	case Button1 : block_copy(); break;
			case Button2 : block_move(); break;
			case Button3 : block_hide(); break;
		}
	}
	else if (event->button==Button2)
	{	
		if (block.start>block.end) started=1;
		if (started) block_end();
		else block_start();
		started=!started;
	}
}

#ifdef SUN
#ifndef COMPOSE
#define COMPOSE
#endif
#ifndef NOIBM
#define NOIBM
#endif
#endif

int translate (XKeyEvent *event)
/* Translate events into key codes */
{
	int length,key;
	char buffer[65];
	KeySym keysym;
	static XComposeStatus status;
#ifdef COMPOSE
	static int composing=0;
#endif

	key=0;
	length=XLookupString(event,buffer,64,&keysym,&status);
	buffer[length]=0;
/*	printf("%lX\n",(long)keysym); */
	if (event->state & ControlMask)
	{	switch (keysym)
		{
			case XK_Up : key=TBEGIN; break;
			case XK_Down : key=TEND; break;
			case XK_Left : key=WLEFT; break;
			case XK_Right : key=WRIGHT; break;
			case XK_F1 : 
#ifdef SUN
			case XK_Help :
#endif
				key=TBBEGIN; break;
			case XK_F2 : key=TBEND; break;
			case XK_F3 : key=TBCOPY; break;
			case XK_F4 : key=TBMOVE; break;
			case XK_F5 : key=TBDELETE; break;
			case XK_F6 : key=TBHIDE; break;
			case XK_F7 : key=TBLOAD; break;
			case XK_F8 : key=TBSAVE; break;
			case XK_F9 : key=TBFORMAT; break;
			case XK_F10 : key=TRECORD; break;
			case XK_BackSpace : key=LDELETE; break;
			case XK_Next : 
#ifdef SUN
			case  XK_R15 : 
#endif
				key=TEND; break;
			case XK_Prior : 
#ifdef SUN
			case XK_R9 : 
#endif		
				key=TBEGIN; break;
			case XK_Return : key=LRETURN; break;
		}
		if (key) return key;
	}
	if (event->state & ShiftMask)
	{	switch(keysym)
		{
			case XK_Up : key=PUP; break;
			case XK_Down : key=PDOWN; break;
			case XK_Left : key=LLEFT; break;
			case XK_Right : key=LRIGHT; break;
			case XK_F1 : 
#ifdef SUN
			case XK_Help :
#endif
				key=TLOAD; break;
			case XK_F2 : key=TSAVE; break;
			case XK_F3 : key=TSAVEDUP; break;
			case XK_F4 : key=TSAVEAS; break;
			case XK_F5 : key=LDELETE; break;
			case XK_F6 : key=TOLOAD; break;
			case XK_F7 : key=TBLOAD; break;
			case XK_F8 : key=TBSAVE; break;
			case XK_F9 : key=TCLOSE; break;
			case XK_F10 : key=TCLOSEA; break;
			case 0xC4 :
#ifdef NOIBM
				key=196; break;
#else
				key=142 ; break;
#endif
			case 0xD6 : 
#ifdef NOIBM
				key=214; break;
#else
				key=153 ; break;
#endif
			case 0xDC : 
#ifdef NOIBM
				key=220; break;
#else
				key=154 ; break;
#endif
			case 0xA7 : key=0xF5; break;
			case XK_Next : 
#ifdef SUN
			case  XK_R15 :
#endif
				key=HPDOWN; break;
			case XK_Prior :
#ifdef SUN
			case  XK_R9 : 
#endif
				key=HPUP; break;
			case XK_Return : key=LRETURN; break;
			case XK_Pause : key=TRECORD; break;
			case XK_degree : key=''; break;
		}
		if (key) return key;
	}
	switch (keysym)
	{
		case XK_Return : key=TRETURN; break;
		case XK_Delete : 
#ifndef BACKSPACE
		key=TDELETE; break;
#endif
		case XK_BackSpace : key=TBACKSPACE; break;
		case XK_Insert : key=TINSERT; break;
		case XK_Up : key=CUP; break;
		case XK_Down : key=CDOWN; break;
		case XK_Right : key=CRIGHT; break;
		case XK_Left : key=CLEFT; break;
#ifdef SUN
		case XK_Help :
#endif
		case XK_F1 : key=TSEARCH; break;
		case XK_F2 : key=TREPLACE; break;
		case XK_F3 : key=TAGAIN; break;
		case XK_F4 : key=TLINK; break;
		case XK_F5 : key=TBRACKETS; break;
		case XK_F6 : key=TWFIND; break;
		case XK_F7 : key=TCYCLE; break;
		case XK_F8 : key=TSAVEALL; break;
		case XK_F9 : key=TGOTO; break;
		case XK_F10 : key=TMAKRO; break;
		case XK_KP_Enter : key=TRETURN; break;
		case XK_Tab : key=9; break;
		case XK_End : 
#ifdef SUN
		case XK_R13 : 
#endif
			key=LRIGHT; break;
		case XK_Home :
		case XK_Begin : 
#ifdef SUN
		case XK_R7 :
#endif
			key=LLEFT; break;
#ifdef SUN
		case XK_R9 :
#endif
		case XK_Prior : key=PUP; break;
#ifdef SUN
		case XK_R15 :
#endif
		case XK_Next : key=PDOWN; break;
		case 0xE4 :
#ifdef NOIBM
			key=228; break;
#else
			key=132 ; break;
#endif
		case 0xF6 : 
#ifdef NOIBM
			key=246; break;
#else
			key=148 ; break;
#endif
		case 0xFC :
#ifdef NOIBM
			key=252; break;
#else
			key=129 ; break;
#endif
		case 0xDF :
#ifdef NOIBM
			key=223; break;
#else
			key=225 ; break;
#endif
		case XK_Escape : key=TMENU; break;
		case XK_KP_0 : key='0'; break;
		case XK_KP_1 : key='1'; break;
		case XK_KP_2 : key='2'; break;
		case XK_KP_3 : key='3'; break;
		case XK_KP_4 : key='4'; break;
		case XK_KP_5 : key='5'; break;
		case XK_KP_6 : key='6'; break;
		case XK_KP_7 : key='7'; break;
		case XK_KP_8 : key='8'; break;
		case XK_KP_9 : key='9'; break;
		case XK_KP_Add : key='+'; break;
		case XK_KP_Subtract : key='-'; break;
		case XK_KP_Multiply : key='*'; break;
		case XK_KP_Divide : key='/'; break;
		case XK_KP_Separator : key='.'; break;
		case XK_Pause : key=TMAKRO; break;
		case XK_acute : key='\''; break;
		case XK_dead_circumflex : key='^'; break;
		case XK_dead_tilde : key='~'; break;
		case XK_dead_acute : key='\''; break;
		case XK_dead_grave : key='`'; break;
#ifdef COMPOSE
		case XK_Multi_key : composing=!composing; break;
#endif
	}
	if (key) return key;
	if (length>0)
	{
		key=buffer[0];
		if (event->state & Mod1Mask)
		{
			switch(key)
			{
				case 'c' :
				case 'C' : key=TABORT; break;
				case 'x' :
				case 'X' : key=TQUIT; break;
				case 'q' :
				case 'Q' : key=TCLOSE; break;
				case 'w' :
				case 'W' : key=TCYCLE; break;
				case 'l' :
				case 'L' : key=TBLINE; break;
				case 'f' :
				case 'F' : key=TSEARCH; break;
				case 'r' :
				case 'R' : key=TREPLACE; break;
				case 'g' :
				case 'G' : key=TAGAIN; break;
				case 's' :
				case 'S' : key=TSSAVE; break;
				case 'j' :
				case 'J' : key=TBLEFT; break;
				case 'k' :
				case 'K' : key=TBRIGHT; break;
				case 'u' :
				case 'U' : key=TUNDO; break;
				case '1' : key=TSET1; break;
				case '2' : key=TSET2; break;
				case '3' : key=TSET3; break;
				case '4' : key=TSET4; break;
				case '5' : key=TGOTO1; break;
				case '6' : key=TGOTO2; break;
				case '7' : key=TGOTO3; break;
				case '8' : key=TGOTO4; break;
				case 'o' :
				case 'O' : key=TPARAMS; break;
				case 'i' :
				case 'I' : key=TCINFO; break;
				case 't' :
				case 'T' : key=TCHECK; break;
				case 'a' :
				case 'A' : key=TCINSERT; break;
				case 'y' :
				case 'Y' : key=LDELETE; break;
				case 'n' :
				case 'N' : key=TLOAD; break;
				case 'm' :
				case 'M' : key=TSAVEAS; break;
				case 'p' :
				case 'P' : key=TPFORMAT; break;
				case 'b' :
				case 'B' : key=TSAVEDUP; break;
			}
			return key;
		}
		switch(key)
		{	case 3 : key=TABORT; break;
			case 0x18 : key=TQUIT; break;
			case 6 : key=TSEARCH; break;
			case 7 : key=TAGAIN; break;
			case 0x12 : key=TREPLACE; break;
			case 0x0A : key=TBLEFT; break;
			case 0x0B : key=TBRIGHT; break;
			case 0x0C : key=TBLINE; break;
			case 0x0D : key=TRETURN; break;
			case 0x0F : key=TPARAMS; break;
			case 9 : key=TCINFO; break;
			case 0x11 : key=TQUIT; break;
			case 0x17 : key=TCYCLE; break;
			case 0x13 : key=TSAVE; break;
			case 0x15 : key=TUNDO; break;
		}
#ifdef COMPOSE
		switch (composing)
		{	case 1 :
				switch (key)
				{	case 's' : composing='s'; key=0; break;
					case '\"' : composing='\"'; key=0; break;
					default : composing=0;
				}
				break;
			case 's' :
				if (key=='s') key=0xdf;
				composing=0;
				break;
			case '\"' :
				switch(key)
				{	case 'a' : key=0xe4; break;
					case 'o' : key=0xf6; break;
					case 'u' : key=0xfc; break;
					case 'A' : key=0xc4; break;
					case 'U' : key=0xdc; break;
					case 'O' : key=0xd6; break;
				}
				composing=0;
				break;
			default : composing=0;
		}
#endif
		return key;
	}
	return key;
}

